package fin;

abstract class Collezione implements Finestra { 
  private static final int DEFAULT_SIZE = 10;
  protected Finestra[] finestre;
  protected int conta;
  
  public Collezione(int max) { 
    finestre = new Finestra[max];
  }

  public Collezione() {
    this(DEFAULT_SIZE);
  }
  
  public void aggiungi(Finestra f) { 
    if(piena())
      aumentaCapienza();
    finestre[conta++] = f;
  }

  protected boolean piena() {
    return conta == finestre.length;
  }
  
  protected boolean vuota(){
    return conta == 0;
  }

  protected void aumentaCapienza() {
    Finestra[] tmp = new Finestra[2*finestre.length];
    System.arraycopy(finestre, 0, tmp, 0, finestre.length);
    finestre = tmp;
  }
  
  public Finestra estrai() { 
    if(vuota())
      return null;
    Finestra f = finestre[--conta];
    finestre[conta] = null;
    return f;
  }
  
  abstract protected void aggiorna(Rettangolo r1, Rettangolo r2);

  public Rettangolo dimensioni() { 
    Rettangolo tmp = new Rettangolo(0, 0);
    for(int i=0; i<conta; i++) { 
      Finestra f = finestre[i];
      aggiorna(tmp, f.dimensioni());
    }
    return tmp;
  }
}
